local selfDetail = {}
local targetDetail = {}
local cti = UI.CreateContext("ctiContext")
local lastUpdateTime = Inspect.Time.Real()
local permaTarget
local combatCheck = false

ClassColors = {
	["cleric"] =  {0.0, 1.0, 0.5, 1.0},
	["mage"] = 	  {1.0, 0.0, 1.0, 1.0},
	["rogue"] =   {1.0, 1.0, 0.0, 1.0},
	["warrior"] = {1.0, 0.0, 0.0, 1.0},
	["none"] =	  {1.0, 1.0, 1.0, 1.0},		
}
local function nameColor(details)
	if not details then 
		return { 1,1,0,1 }
	end
	if details.player then
		return ClassColors[details.calling]
	elseif details.relation == "friendly" then
		return { 0, 1, 0, 1}
	elseif details.relation == "hostile" then
		return { 1, 0, 0, 1}
	else
		return { 1, 1, 0, 1}
	end
end
local ctiV = {
	gui = {

		scaleFactor = 100,
		updateInterval = .5,            --[[ Frequency Interval --]]

		options = {
			panel2 = {
				visible = false
				},
			panel = {
				visible = false
				},
			},
		position = {
			x = 20,
			y = 0   },
		backgroundColor = { 
			hp = {
				red = 0,
				green = 0,
				blue = 0,
				alpha = .25
			},
			hpBar = {
				red = 1,
				green = 0,
				blue = 0,
				alpha = .33
			},
			mp = {
				red = 0,
				green = 0,
				blue = 0,
				alpha = .25
			},
			mpBar = {
				red = 1,
				green = 0,
				blue = 0,
				alpha = .33
			},
			ep = {
				red = 0,
				green = 0,
				blue = 0,
				alpha = .25
			},
			epBar = {
				red = 1,
				green = 0,
				blue = 0,
				alpha = .33
			},
			cp = {
				red = 1,
				green = 1,
				blue = .5,
				alpha = .33
			},
		}
	}
}

																		-- Unit Frame Build---------

cti.target = UI.CreateFrame("Frame","Base Frame",cti)

cti.target.name = UI.CreateFrame("Text","Target Name",cti.target)
cti.target.nameToken = UI.CreateFrame("Text","Target Raid Token",cti.target)
cti.target.nameTokenHighlight = UI.CreateFrame("Text","Target Raid Token",cti.target)

cti.target.nameRaidToken = UI.CreateFrame("Text","Target Raid Token",cti.target)

cti.target.hpbar = UI.CreateFrame("Text","HP Base Bar",cti.target)
cti.target.mpbar = UI.CreateFrame("Text","MP Base Bar",cti.target)
cti.target.epbar = UI.CreateFrame("Text","EP Base Bar",cti.target)

cti.target.hp = UI.CreateFrame("Text","Target Health",cti.target.hpbar)
cti.target.mp = UI.CreateFrame("Text","Target Mana",cti.target.mpbar)
cti.target.ep = UI.CreateFrame("Text","Target Energy",cti.target.epbar)
cti.target.cp = UI.CreateFrame("Text","Target Combo Points",cti.target)

cti.target.hppct = UI.CreateFrame("Text","HP Base Bar",cti.target.hp)
cti.target.mppct = UI.CreateFrame("Text","MP Base Bar",cti.target.mp)
cti.target.eppct = UI.CreateFrame("Text","EP Base Bar",cti.target.ep)

cti.target.dist = UI.CreateFrame("Text","Distance to Target", cti.target) -----------


cti.target.roleTank = UI.CreateFrame("Texture","Tank Role Icon",cti.target)
cti.target.roleTank:SetTexture("CursorTargetInfo","tank.jpg")
cti.target.roleTank:SetPoint("BOTTOMRIGHT",cti.target.name,"TOPLEFT")
cti.target.roleTank:SetVisible(false)

cti.target.roleHeal = UI.CreateFrame("Texture","Heal Role Icon",cti.target)
cti.target.roleHeal:SetTexture("CursorTargetInfo","heal.jpg")
cti.target.roleHeal:SetPoint("BOTTOMRIGHT",cti.target.name,"TOPLEFT")
cti.target.roleHeal:SetVisible(false)

cti.target.roleDps = UI.CreateFrame("Texture","DPS Role Icon",cti.target)
cti.target.roleDps:SetTexture("CursorTargetInfo","dps.jpg")
cti.target.roleDps:SetPoint("BOTTOMRIGHT",cti.target.name,"TOPLEFT")
cti.target.roleDps:SetVisible(false)

cti.target.roleSupport = UI.CreateFrame("Texture","Support Role Icon",cti.target)
cti.target.roleSupport:SetTexture("CursorTargetInfo","support.jpg")
cti.target.roleSupport:SetPoint("BOTTOMRIGHT",cti.target.name,"TOPLEFT")
cti.target.roleSupport:SetVisible(false)







cti.options = UI.CreateFrame("Texture","Options Button",cti)
cti.options.panel = UI.CreateFrame("RiftWindow","Option Window", cti.options)
cti.options.panel:SetTitle("CTi Options (Saves on Exit)")
cti.options.panel:SetAlpha(.75)

cti.options.panel2 = UI.CreateFrame("RiftWindow","Option Window 2", cti.options)
cti.options.panel2:SetTitle("CTi Options Pane 2")
cti.options.panel2:SetAlpha(.75)
cti.options.panel2:SetVisible(false)

																		-- Colors ------------------
cti.target.name:SetBackgroundColor(0,0,0,.25)
cti.target.hp:SetBackgroundColor(0,0,0,0)
cti.target.mp:SetBackgroundColor(0,0,0,0)
cti.target.ep:SetBackgroundColor(0,0,0,0)
cti.target.cp:SetBackgroundColor(1,1,.50,.25)

cti.target.hpbar:SetBackgroundColor(1,0,0,.33)
cti.target.mpbar:SetBackgroundColor(0,0,1,.33)
cti.target.epbar:SetBackgroundColor(1,1,0,.33)

cti.target.hppct:SetBackgroundColor(1,0,0,.33)
cti.target.mppct:SetBackgroundColor(0,0,1,.33)
cti.target.eppct:SetBackgroundColor(1,1,0,.33)

cti.target.dist:SetBackgroundColor(.1,.1,.1,.5)   ----- dist


cti.options:SetTexture("CursorTargetInfo","CTi_Menu_Icon.JPG")
cti.options:SetAlpha(.90)

cti.options.panel:SetBackgroundColor(.15,.15,.15,.5)
cti.options.panel2:SetBackgroundColor(.15,.15,.15,.5)

cti.target.nameToken:SetBackgroundColor(0,0,0,1)
cti.target.nameTokenHighlight:SetBackgroundColor(1,1,1,1)
cti.target.nameRaidToken:SetBackgroundColor(0,0,0,.33)


																		-- Size --------------------



function sizingit()

cti.target.name:SetFontSize(16*(cti.options.panel2.scaling:GetPosition()/100))
cti.target.hp:SetFontSize(12*(cti.options.panel2.scaling:GetPosition()/100))
cti.target.mp:SetFontSize(12*(cti.options.panel2.scaling:GetPosition()/100))
cti.target.ep:SetFontSize(12*(cti.options.panel2.scaling:GetPosition()/100))
cti.target.cp:SetFontSize(40*(cti.options.panel2.scaling:GetPosition()/100))

cti.target.dist:SetFontSize(12*(cti.options.panel2.scaling:GetPosition()/100))


	cti.target.name:SetWidth(100*(cti.options.panel2.scaling:GetPosition()/100))
	
	cti.target.name:ClearWidth()
	
	lenname = cti.target.name:GetWidth()

cti.target.name:SetWidth(lenname)
cti.target.hp:SetWidth(lenname)
cti.target.mp:SetWidth(lenname)
cti.target.ep:SetWidth(lenname)

end

cti.options.panel:SetHeight(500)
cti.options.panel:SetWidth(600)

cti.options.panel2:SetHeight(500)
cti.options.panel2:SetWidth(600)

cti.target.nameToken:SetFontSize(16)
cti.target.nameTokenHighlight:SetFontSize(18)
cti.target.nameRaidToken:SetFontSize(35)
																		-- Set Points ---------------
cti.target:SetPoint("CENTER",UIParent,"CENTER")
cti.target.name:SetPoint("TOPLEFT",cti.target,"TOPLEFT")
cti.target.hp:SetPoint("TOPLEFT",cti.target.name,"BOTTOMLEFT")
cti.target.hpbar:SetPoint("TOPLEFT",cti.target.hp,"TOPLEFT")
cti.target.mp:SetPoint("TOPLEFT",cti.target.hp,"BOTTOMLEFT")
cti.target.mpbar:SetPoint("TOPLEFT",cti.target.mp,"TOPLEFT")
cti.target.ep:SetPoint("TOPLEFT",cti.target.mp,"BOTTOMLEFT")
cti.target.epbar:SetPoint("TOPLEFT",cti.target.ep,"TOPLEFT")
cti.target.cp:SetPoint("TOPRIGHT",cti.target.name,"TOPLEFT")
cti.target.hppct:SetPoint("TOPLEFT",cti.target.hp,"TOPRIGHT")
cti.target.mppct:SetPoint("TOPLEFT",cti.target.mp,"TOPRIGHT")
cti.target.eppct:SetPoint("TOPLEFT",cti.target.ep,"TOPRIGHT")

cti.target.dist:SetPoint("BOTTOMRIGHT", cti.target.name, "TOPRIGHT") -------------DIST

--cti.target.dist:Set





-------------------------------------------



cti.target.nameToken:SetPoint("TOPLEFT",cti.target.name,"TOPRIGHT")
cti.target.nameTokenHighlight:SetPoint("CENTER",cti.target.nameToken,"CENTER")

cti.target.nameRaidToken:SetPoint("BOTTOMLEFT",cti.target.name,"TOPLEFT")


cti.options:SetPoint("TOPRIGHT",UIParent,"TOPRIGHT")

cti.options.panel:SetPoint("CENTER",UIParent,"CENTER")

cti.options.panel2:SetPoint("CENTER",UIParent,"CENTER")

cti.options.panel:SetVisible (false)
																		-- hide cp, mp
cti.target.mp:SetVisible(false)
cti.target.mpbar:SetVisible(false)
cti.target.ep:SetVisible(false)
cti.target.epbar:SetVisible(false)
cti.target.cp:SetVisible(false)

cti.target.mppct:SetVisible(false)
cti.target.eppct:SetVisible(false)
																		-- Build Option Window's Guts ----
cti.options.panel.options = UI.CreateFrame("RiftButton","Options Button",cti.options.panel)
cti.options.panel.options:SetText("Close")
cti.options.panel.options:SetPoint("BOTTOMRIGHT",cti.options.panel,"BOTTOMRIGHT",-9,-7)

cti.options.panel.options.to2 = UI.CreateFrame("RiftButton","Options Page 2 Button",cti.options.panel)
cti.options.panel.options.to2:SetText("Page 2")


cti.options.panel.xostxt = UI.CreateFrame("Text","Text for Slider", cti.options.panel)
cti.options.panel.xostxt:SetText("Horizontal Offest : (" .. tostring(ctiV.gui.position.x) .. ")")
cti.options.panel.xostxt:SetPoint("TOPLEFT",cti.options.panel,"TOPLEFT", 25, 60)
cti.options.panel.xostxt:SetVisible(true)
cti.options.panel.xostxt:SetWidth(200)


cti.options.panel.xos = UI.CreateFrame("RiftSlider","X Offest Slider", cti.options.panel)
cti.options.panel.xos:SetPoint("TOPLEFT",cti.options.panel.xostxt,"TOPRIGHT",30,5)
cti.options.panel.xos:SetWidth(300)
cti.options.panel.xos:SetHeight(15)
cti.options.panel.xos:SetRange(-200,200)
cti.options.panel.xos:SetPosition(ctiV.gui.position.x)
cti.options.panel.xos:SetVisible(true)


cti.options.panel.preview = UI.CreateFrame("Texture","Options Button",cti.options.panel)
cti.options.panel.preview:SetTexture("CursorTargetInfo","RiftCursor.JPG")
cti.options.panel.preview:SetVisible(true)
cti.options.panel.preview:SetPoint("TOPCENTER",cti.options.panel,"CENTER",0,75)

cti.options.panel.previewTxt = UI.CreateFrame("Text","Options Button",cti.options.panel)
cti.options.panel.previewTxt:SetText("Target Box")
cti.options.panel.previewTxt:SetBackgroundColor(0,0,0,.80)
cti.options.panel.previewTxt:SetVisible(true)
cti.options.panel.previewTxt:SetWidth(150)
cti.options.panel.previewTxt:SetHeight(100)


cti.options.panel.yostxt = UI.CreateFrame("Text","Text for Slider", cti.options.panel)
cti.options.panel.yostxt:SetText("Vertical Offest : (" .. tostring(ctiV.gui.position.y) .. ")")
cti.options.panel.yostxt:SetPoint("TOPCENTER",cti.options.panel.xostxt,"BOTTOMCENTER")
cti.options.panel.yostxt:SetVisible(true)
cti.options.panel.yostxt:SetWidth(200)

cti.options.panel.yos = UI.CreateFrame("RiftSlider","Y Offest Slider", cti.options.panel)
cti.options.panel.yos:SetPoint("TOPLEFT",cti.options.panel.yostxt,"TOPRIGHT",30,5)
cti.options.panel.yos:SetWidth(300)
cti.options.panel.yos:SetHeight(15)
cti.options.panel.yos:SetRange(-200,200)
cti.options.panel.yos:SetPosition(ctiV.gui.position.y)
cti.options.panel.yos:SetVisible(true)

cti.options.panel.mOver = UI.CreateFrame("RiftCheckbox","Mouse Over Checkbox",cti.options.panel)
cti.options.panel.mOver:SetPoint("TOPLEFT",cti.options.panel.yostxt,"BOTTOMLEFT",0,10)
cti.options.panel.mOverTxt = UI.CreateFrame("Text","Mover text",cti.options.panel)
cti.options.panel.mOverTxt:SetText("Mouse Over Info INSTEAD of Target Info")
cti.options.panel.mOverTxt:SetPoint("TOPLEFT",cti.options.panel.mOver,"TOPRIGHT")
cti.options.panel.mOver:SetBackgroundColor(0,0,0,1)
cti.options.panel.mOverTxt:SetBackgroundColor(0,0,0,1)
cti.options.panel.mOver:SetHeight(cti.options.panel.mOverTxt:GetHeight())

cti.options.panel.focusTxt = UI.CreateFrame("Text","Resources Text",cti.options.panel)
cti.options.panel.focusTxt:SetText("Resource Allotment: " .. tostring(ctiV.gui.updateInterval) .. "ms")
cti.options.panel.focusTxt:SetPoint("TOPLEFT",cti.options.panel.mOver,"BOTTOMLEFT",0,15)
cti.options.panel.focusTxt:SetWidth(200)
cti.options.panel.focus = UI.CreateFrame("RiftSlider","Resources",cti.options.panel)
cti.options.panel.focus:SetPoint("TOPLEFT",cti.options.panel.focusTxt,"TOPRIGHT",30,5)
cti.options.panel.focus:SetRange(1, 1000)
cti.options.panel.focus:SetPosition( ctiV.gui.updateInterval*1000 )
cti.options.panel.focus:SetWidth(300)
cti.options.panel.focusTxt2 = UI.CreateFrame("Text","Resources Text",cti.options.panel)
cti.options.panel.focusTxt2:SetText("( 500ms uses less CPU but is not as quickly updated, 1ms uses more CPU but is more accuately Timed )")
cti.options.panel.focusTxt2:SetPoint("TOPLEFT",cti.options.panel.focusTxt,"BOTTOMLEFT",0,0)
cti.options.panel.focusTxt3 = UI.CreateFrame("Text","Resources Text",cti.options.panel)
cti.options.panel.focusTxt3:SetText("( 250ms seems to be a good balance but not everyone will not like updates every 1/4 sec )")
cti.options.panel.focusTxt3:SetPoint("TOPLEFT",cti.options.panel.focusTxt2,"BOTTOMLEFT",0,0)
cti.options.panel.focusTxt3:SetWidth(cti.options.panel.focusTxt2:GetWidth())
cti.options.panel.focusTxt2:SetBackgroundColor(0,0,0,1)
cti.options.panel.focusTxt3:SetBackgroundColor(0,0,0,1)

cti.options.panel2.to1 = UI.CreateFrame("RiftButton","Options 2 Button",cti.options.panel2)
cti.options.panel2.to1:SetText("Page 1")
cti.options.panel2.to1:SetPoint("BOTTOMLEFT",cti.options.panel2,"BOTTOMLEFT",9,-7)
cti.options.panel.options.to2:SetPoint("BOTTOMLEFT",cti.options.panel2.to1,"BOTTOMRIGHT",-15,0)

cti.options.panel2.name = UI.CreateFrame("RiftCheckbox","Option 2 Name Visible",cti.options.panel2)
cti.options.panel2.nameTxt = UI.CreateFrame("Text","Option 2 Name Visible Text",cti.options.panel2)

cti.options.panel2.name:SetPoint("TOPLEFT", cti.options.panel2,"TOPLEFT",25,60)
cti.options.panel2.nameTxt:SetPoint("TOPLEFT", cti.options.panel2.name,"TOPRIGHT")
cti.options.panel2.nameTxt:SetText("Name Visible")
cti.options.panel2.name:SetChecked(true)

cti.options.panel2.level = UI.CreateFrame("RiftCheckbox","Option 2 Level Visible",cti.options.panel2)
cti.options.panel2.levelTxt = UI.CreateFrame("Text","Option 2 Level Visible Text",cti.options.panel2)

cti.options.panel2.level:SetPoint("TOPLEFT", cti.options.panel2.name,"BOTTOMLEFT",0,4)
cti.options.panel2.levelTxt:SetPoint("TOPLEFT", cti.options.panel2.level,"TOPRIGHT")
cti.options.panel2.levelTxt:SetText("Level Visible")
cti.options.panel2.level:SetChecked(true)


cti.options.panel2.hp = UI.CreateFrame("RiftCheckbox","Option 2 Combo Visible",cti.options.panel2)
cti.options.panel2.hpTxt = UI.CreateFrame("Text","Option 2 Combo Visible Text",cti.options.panel2)

cti.options.panel2.hp:SetPoint("TOPLEFT", cti.options.panel2.level,"BOTTOMLEFT",0,16)
cti.options.panel2.hpTxt:SetPoint("TOPLEFT", cti.options.panel2.hp,"TOPRIGHT")
cti.options.panel2.hpTxt:SetText("Health Points Visible")
cti.options.panel2.hp:SetChecked(true)


cti.options.panel2.mp = UI.CreateFrame("RiftCheckbox","Option 2 MP Visible",cti.options.panel2)
cti.options.panel2.mpTxt = UI.CreateFrame("Text","Option 2 MP Visible Text",cti.options.panel2)

cti.options.panel2.mp:SetPoint("TOPLEFT", cti.options.panel2.hp,"BOTTOMLEFT",0,4)
cti.options.panel2.mpTxt:SetPoint("TOPLEFT", cti.options.panel2.mp,"TOPRIGHT")
cti.options.panel2.mpTxt:SetText("Mana Points Visible")
cti.options.panel2.mp:SetChecked(true)

cti.options.panel2.ep = UI.CreateFrame("RiftCheckbox","Option 2 Energy Visible",cti.options.panel2)
cti.options.panel2.epTxt = UI.CreateFrame("Text","Option 2 Energy Visible Text",cti.options.panel2)

cti.options.panel2.ep:SetPoint("TOPLEFT", cti.options.panel2.mp,"BOTTOMLEFT",0,4)
cti.options.panel2.epTxt:SetPoint("TOPLEFT", cti.options.panel2.ep,"TOPRIGHT")
cti.options.panel2.epTxt:SetText("Energy Points Visible (Power or Energy)")
cti.options.panel2.ep:SetChecked(true)

cti.options.panel2.hpPct = UI.CreateFrame("RiftCheckbox","Option 2 hpPct Visible",cti.options.panel2)
cti.options.panel2.hpPctTxt = UI.CreateFrame("Text","Option 2 hpPctTxt Visible Text",cti.options.panel2)

cti.options.panel2.hpPct:SetPoint("TOPLEFT", cti.options.panel2.hpTxt,"TOPRIGHT",100,0)
cti.options.panel2.hpPctTxt:SetPoint("TOPLEFT", cti.options.panel2.hpPct,"TOPRIGHT")
cti.options.panel2.hpPctTxt:SetText("Health Percentage Visible")
cti.options.panel2.hpPct:SetChecked(true)

cti.options.panel2.mpPct = UI.CreateFrame("RiftCheckbox","Option 2 mpPct Visible",cti.options.panel2)
cti.options.panel2.mpPctTxt = UI.CreateFrame("Text","Option 2 mpPctTxt Visible Text",cti.options.panel2)

cti.options.panel2.mpPct:SetPoint("TOPLEFT", cti.options.panel2.hpPct,"BOTTOMLEFT",0,4)
cti.options.panel2.mpPctTxt:SetPoint("TOPLEFT", cti.options.panel2.mpPct,"TOPRIGHT")
cti.options.panel2.mpPctTxt:SetText("Mana Percentage Visible")
cti.options.panel2.mpPct:SetChecked(true)

cti.options.panel2.epPct = UI.CreateFrame("RiftCheckbox","Option 2 mpPct Visible",cti.options.panel2)
cti.options.panel2.epPctTxt = UI.CreateFrame("Text","Option 2 mpPctTxt Visible Text",cti.options.panel2)

cti.options.panel2.epPct:SetPoint("TOPLEFT", cti.options.panel2.mpPct,"BOTTOMLEFT",0,4)
cti.options.panel2.epPctTxt:SetPoint("TOPLEFT", cti.options.panel2.epPct,"TOPRIGHT")
cti.options.panel2.epPctTxt:SetText("Energy Percentage Visible")
cti.options.panel2.epPct:SetChecked(true)

cti.options.panel2.combo = UI.CreateFrame("RiftCheckbox","Option 2 Combo Visible",cti.options.panel2)
cti.options.panel2.comboTxt = UI.CreateFrame("Text","Option 2 Combo Visible Text",cti.options.panel2)

cti.options.panel2.combo:SetPoint("TOPLEFT", cti.options.panel2.ep,"BOTTOMLEFT",0,16)
cti.options.panel2.comboTxt:SetPoint("TOPLEFT", cti.options.panel2.combo,"TOPRIGHT")
cti.options.panel2.comboTxt:SetText("Combo Points Visible (Player is Rogue/Warrior only.)")
cti.options.panel2.combo:SetChecked(true)

cti.options.panel2.roles = UI.CreateFrame("RiftCheckbox","Option 2 Roles Visible",cti.options.panel2)
cti.options.panel2.rolesTxt = UI.CreateFrame("Text","Option 2 Roles Visible Text",cti.options.panel2)

cti.options.panel2.roles:SetPoint("TOPLEFT", cti.options.panel2.combo,"BOTTOMLEFT",0,16)
cti.options.panel2.rolesTxt:SetPoint("TOPLEFT", cti.options.panel2.roles,"TOPRIGHT")
cti.options.panel2.rolesTxt:SetText("Role Visible")
cti.options.panel2.roles:SetChecked(true)

cti.options.panel2.combat = UI.CreateFrame("RiftCheckbox","Option 2 Visible in Combat",cti.options.panel2)
cti.options.panel2.combatTxt = UI.CreateFrame("Text","Option 2 Visible in Combat Text",cti.options.panel2)

cti.options.panel2.combat:SetPoint("TOPLEFT", cti.options.panel2.roles,"BOTTOMLEFT",0,16)
cti.options.panel2.combatTxt:SetPoint("TOPLEFT", cti.options.panel2.combat,"TOPRIGHT")
cti.options.panel2.combatTxt:SetText("Only Visible while in Combat")
cti.options.panel2.combat:SetChecked(true)

cti.options.panel2.scaling = UI.CreateFrame("RiftSlider","Option 2 Scaling Factor",cti.options.panel2)
cti.options.panel2.scalingTxt = UI.CreateFrame("Text","Option 2 Scaling Factor Text",cti.options.panel2)

cti.options.panel2.scalingTxt:SetPoint("TOPLEFT", cti.options.panel2.combat,"BOTTOMLEFT",0,16)
cti.options.panel2.scaling:SetPoint("TOPLEFT", cti.options.panel2.scalingTxt,"TOPLEFT",250,0)

cti.options.panel2.scalingTxt:SetText("Scaling Factor : ("..tostring(cti.options.panel2.scaling:GetPosition()).."%)")

cti.options.panel2.scaling:SetWidth(300)
cti.options.panel2.scaling:SetHeight(15)
cti.options.panel2.scaling:SetRange(1,400)
cti.options.panel2.scaling:SetPosition(ctiV.gui.scaleFactor)
cti.options.panel2.scaling:SetVisible(true)

cti.options.panel2.close = UI.CreateFrame("RiftButton","Options Button",cti.options.panel2)
cti.options.panel2.close:SetText("Close")
cti.options.panel2.close:SetPoint("BOTTOMRIGHT",cti.options.panel2,"BOTTOMRIGHT",-9,-7)

function cti.options.panel2.close.Event:LeftClick()
		cti.options.panel:SetVisible(false)
		cti.options.panel2:SetVisible(false)
		
		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			roles = cti.options.panel2.roles:GetChecked(),
			combatCheck = cti.options.panel2.combat:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
			
		}
end

function cti.options.panel.options.to2.Event:LeftClick()
		cti.options.panel:SetVisible(false)
		cti.options.panel2:SetVisible(true)
		
		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			roles = cti.options.panel2.roles:GetChecked(),
			combatCheck = cti.options.panel2.combat:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
		}
end

function cti.options.panel2.to1.Event:LeftClick()
		cti.options.panel2:SetVisible(false)
		cti.options.panel:SetVisible(true)

		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			roles = cti.options.panel2.roles:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
		}
end

function cti.options.panel.mOverTxt.Event:LeftClick()
	if cti.options.panel.mOver:GetChecked() == true then
		cti.options.panel.mOver:SetChecked(false)
	else
		cti.options.panel.mOver:SetChecked(true)
	end
end

function cti.options.panel.focus.Event:SliderChange()
	ctiV.gui.updateInterval = cti.options.panel.focus:GetPosition()
	cti.options.panel.focusTxt:SetText("Resource Allotment: ( " .. tostring(ctiV.gui.updateInterval) .. "ms )")
	end

function cti.options.panel.yos.Event:SliderChange()
	ctiV.gui.position.y = cti.options.panel.yos:GetPosition()
	cti.options.panel.yostxt:SetText("Vertical Offest : (" .. tostring(ctiV.gui.position.y) .. ")")
	
	local myMouse = Inspect.Mouse()
	cti.target:SetPoint("TOPLEFT",UIParent,"TOPLEFT",myMouse.x + cti.target.cp:GetWidth() + ctiV.gui.position.x ,myMouse.y + ctiV.gui.position.y)

	cti.options.panel.previewTxt:SetPoint("TOPLEFT",cti.options.panel.preview,"TOPLEFT",ctiV.gui.position.x ,ctiV.gui.position.y)
	
end

function cti.options.panel2.scaling.Event:SliderChange()
	ctiV.gui.scaleFactor = cti.options.panel2.scaling:GetPosition()
    cti.options.panel2.scalingTxt:SetText("Scaling Factor : ("..tostring(cti.options.panel2.scaling:GetPosition()).."%)")
	
	local myMouse = Inspect.Mouse()
	
end

																				-- continue load ----------

local function ctiRefresh()

    -- Throttle
    local currentTime = Inspect.Time.Real()
	if currentTime - lastUpdateTime < ctiV.gui.updateInterval/1000 then return end
		lastUpdateTime = currentTime
--	info gather
		if cti.options.panel.mOver:GetChecked() == true then
			targetDetail = Inspect.Unit.Detail("mouseover")
		else
			targetDetail = Inspect.Unit.Detail("player.target")	
		end
		selfDetail = Inspect.Unit.Detail("player")
--info gather
		if targetDetail ~= nil then 
			if targetDetail.offline ~= true then
			
			if targetDetail.level ~= nil then
				cti.target.nameToken:SetText(tostring(targetDetail.level))
			else 
				cti.target.nameToken:SetText("0")
			end
--  RAID TOKEN FIX			
			if targetDetail.mark ~= nil then
				cti.target.nameRaidToken:SetText(tostring(targetDetail.mark))
			else 
				cti.target.nameRaidToken:SetText("")
			end
--  SPECIAL LOOT FIX			
			if targetDetail.guaranteedLoot ~= nil then
				cti.target.nameTokenHighlight:SetText(tostring(targetDetail.level))
				cti.target.nameTokenHighlight:SetAlpha(1)

			else
				cti.target.nameTokenHighlight:SetText(".")
				cti.target.nameTokenHighlight:SetAlpha(0)
				
			end
			if targetDetail.level ~= nil then
			if type(targetDetail.level)=="string" or targetDetail.level >= selfDetail.level+4 then -- Red
				cti.target.nameToken:SetBackgroundColor( 0.75,0,0 )
			else
				if targetDetail.level>=selfDetail.level+2 then -- Orange
					cti.target.nameToken:SetBackgroundColor( 0.75,0.75/2,0 )
				else
					if selfDetail.level+2>=targetDetail.level and targetDetail.level>=selfDetail.level-2 then -- Yellow
						cti.target.nameToken:SetBackgroundColor( 0.75,0.75,0 )
					else -- Green
						if selfDetail.level<=9 and targetDetail.level>=selfDetail.level-4 then
							cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
						else
							if selfDetail.level<=19 and targetDetail.level>=selfDetail.level-5 then
								cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
							else
								if selfDetail.level<=29 and targetDetail.level>=selfDetail.level-6 then
									cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
								else
									if selfDetail.level<=39 and targetDetail.level>=selfDetail.level-7 then
										cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
									else
										if selfDetail.level<=70 and targetDetail.level>=selfDetail.level-8 then
											cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
										else
											if selfDetail.level<=80 and targetDetail.level>=selfDetail.level-8 then
												cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
											else
												if selfDetail.level<=85 and targetDetail.level>=selfDetail.level-9 then
													cti.target.nameToken:SetBackgroundColor( 0,0.75,0 )
												else -- Grey
													cti.target.nameToken:SetBackgroundColor( 0.75,0.75,0.75 )
												end
											end
										end
									end
								end
							end
						end
					end
				end
			end
			end
			end

			--------------------------------------------  stuff for distance
		if selfDetail ~= nil and targetDetail ~= nil then
			distToTarget = math.sqrt(((selfDetail.coordX - targetDetail.coordX)^2)+((selfDetail.coordY - targetDetail.coordY)^2)+((selfDetail.coordZ - targetDetail.coordZ)^2))
			
		end
			--distcomp = "Distance :"+distToTarget
			cti.target.dist:SetText(string.format("Range : %.2fm", distToTarget))
			cti.target.dist:ClearWidth()
----------------------------			
			
			cti.target:SetVisible(true)
			cti.target.name:SetText( targetDetail.name )
	
			if targetDetail.health ~= nil then
				nowHp = tostring(targetDetail.health)
			else
				nowHp = "1"
			end

			if 	targetDetail.healthMax ~= nil then
				nowHpMax = tostring(targetDetail.healthMax)
			else
				nowHpMax = 1
			end

			cti.target.hp:SetText(valShort(tonumber(nowHp)).."/"..valShort(tonumber(nowHpMax)))
			cti.target.hp:SetLayer(-1)
			cti.target.hppct:SetText(string.format("%.0f", tonumber(( (100/tonumber(nowHpMax)) * tonumber(nowHp)))).."%")
			
			if targetDetail.mana ~= nil then
				nowMp = tostring(targetDetail.mana)
			else
				nowMp = "1"
			end
			if targetDetail.manaMax ~= nil then
				nowMpMax = tostring(targetDetail.manaMax)
			else
				nowMpMax = "1"
			end
			cti.target.mp:SetText(valShort(tonumber(nowMp)).."/"..valShort(tonumber(nowMpMax)))
			cti.target.mppct:SetText(string.format("%.0f", tonumber(( (100/tonumber(nowMpMax)) * tonumber(nowMp)))).."%")
			
			if targetDetail.energy ~= nil then
				nowEp = tostring(targetDetail.energy)
			else
				nowEp = "1"
			end
			if targetDetail.energyMax ~= nil then
				nowEpMax = tostring(targetDetail.energyMax)
			else
				nowEpMax = "1"
			end
			cti.target.eppct:SetText(tostring(math.floor( (100/nowEpMax)*nowEp)).."%")
			
			if targetDetail.power ~= nil then
				nowPp = tostring(targetDetail.power)
			else
				nowPp = "1"
			end
			
			if targetDetail.calling == "rogue" then
				cti.target.ep:SetText((nowEp) .. "/" .. (nowEpMax).. " ")
			else if targetDetail.calling == "warrior" then
					cti.target.ep:SetText(nowPp.."%")
				else
					cti.target.ep:SetText("1")
				end
			end
		
			nowCp = tostring(selfDetail.combo)
			cti.target.cp:SetText( nowCp )
	
		else
			cti.target:SetVisible(false)
			
			cti.target.name:SetText( "No Target" )
			cti.target.hp:SetText( "0/0" )
			cti.target.mp:SetText( "0/0" )
			cti.target.ep:SetText( "0/0" )
			cti.target.cp:SetText( "0" )
			nowHp = "1"
			nowMp = "1"
			nowEp = "1"
			nowHpMax = "1"
			nowMpMax = "1"
			nowEpMax = "1"
			nowCp = "0"
		end

	-- Autoresize ---------------	()	
cti.target.name:SetWidth(100*(cti.options.panel2.scaling:GetPosition()/100))
	

	cti.target.name:ClearWidth()
	lenname = cti.target.name:GetWidth()
	
	cti.target.name:SetWidth(lenname)
	cti.target.hp:SetWidth(lenname)		
	cti.target.mp:SetWidth(lenname)		
	cti.target.ep:SetWidth(lenname)		

	
	if cti.options.panel2.name:GetChecked() ~= true then
		cti.target.nameToken:SetWidth(0)
	end	
	
	hpPercent = ( lenname) / ( tonumber(nowHpMax) ) * ( tonumber(nowHp) )
	mpPercent = ( lenname) / ( tonumber(nowMpMax) ) * ( tonumber(nowMp) )
	epPercent = ( lenname) / ( tonumber(nowEpMax) ) * ( tonumber(nowEp) )
	
	if cti.options.panel2.hp:GetChecked() == true then 
		cti.target.hpbar:SetHeight(cti.target.hp:GetHeight())
		cti.target.hppct:SetHeight(cti.target.hp:GetHeight())
		cti.target.hpbar:SetWidth(hpPercent)
	else
		cti.target.hpbar:SetWidth(0)
	end
	if cti.options.panel2.mp:GetChecked() == true then
		cti.target.mpbar:SetHeight(cti.target.mp:GetHeight())
		cti.target.mppct:SetHeight(cti.target.mp:GetHeight())
		cti.target.mpbar:SetWidth(mpPercent)
	else
		cti.target.mpbar:SetWidth(0)
	end
	
	if cti.options.panel2.ep:GetChecked() == true then
		cti.target.epbar:SetHeight(cti.target.ep:GetHeight())
		cti.target.eppct:SetHeight(cti.target.ep:GetHeight())
		cti.target.epbar:SetWidth(epPercent)
	else
		cti.target.epbar:SetWidth(0)
	end
	
	if selfDetail ~= nil then
	if selfDetail.calling == "rogue" then
			cti.target.cp:SetVisible(true)
		else
			if selfDetail.calling == "warrior" then
				cti.target.cp:SetVisible(true)
			else
				cti.target.cp:SetVisible(false)
			end
		end
	end
																				--Adjust bars for class
	if targetDetail ~= nil then

		if targetDetail.calling == "warrior" and oldCalling ~= "warrior" then
			--print("Warrior")
			cti.target.name:SetFontColor(1,0,0,1)

			cti.target.epbar:SetPoint("TOPLEFT",cti.target.hpbar,"BOTTOMLEFT")
			cti.target.ep:SetPoint("TOPLEFT",cti.target.hp,"BOTTOMLEFT")

			cti.target.mpbar:SetVisible(false)
			cti.target.mp:SetVisible(false)
			cti.target.epbar:SetVisible(true)
			cti.target.ep:SetVisible(true)
			
			cti.target.mppct:SetVisible(false)
			cti.target.eppct:SetVisible(true)
			
			oldCalling = "warrior"
		else
			if targetDetail.calling == "rogue" and oldCalling ~= "rogue" then
				cti.target.name:SetFontColor(1,1,0,1)
				cti.target.epbar:SetPoint("TOPLEFT",cti.target.hpbar,"BOTTOMLEFT")
				cti.target.ep:SetPoint("TOPLEFT",cti.target.hp,"BOTTOMLEFT")

				cti.target.mpbar:SetVisible(false)
				cti.target.mp:SetVisible(false)
				cti.target.epbar:SetVisible(true)
				cti.target.ep:SetVisible(true)
			
				cti.target.mppct:SetVisible(false)
				cti.target.eppct:SetVisible(true)
	
			
				oldCalling = "rogue"
			else
				if targetDetail.calling == "cleric" and oldCalling ~= "cleric" then
				--	print("Cleric")
					cti.target.name:SetFontColor(0,1,.5,1)

					cti.target.mp:SetPoint("TOPLEFT",cti.target.hp,"BOTTOMLEFT")
					cti.target.mpbar:SetPoint("TOPLEFT",cti.target.mp,"TOPLEFT")
					cti.target.ep:SetPoint("TOPLEFT",cti.target.mp,"BOTTOMLEFT")
					cti.target.epbar:SetPoint("TOPLEFT",cti.target.ep,"TOPLEFT")

					cti.target.mpbar:SetVisible(true)
					cti.target.mp:SetVisible(true)
					cti.target.epbar:SetVisible(false)
					cti.target.ep:SetVisible(false)
					
					cti.target.mppct:SetVisible(true)
					cti.target.eppct:SetVisible(false)
					
					oldCalling = "cleric"
				else
					if targetDetail.calling == "mage" and oldCalling ~= "mage" then
				--		print("Mage")
						cti.target.name:SetFontColor(1,0,1,1)
						--cti.target.epbar:SetPoint("BOTTOMLEFT",cti.target.hpbar,"TOPLEFT")
						cti.target.mp:SetPoint("TOPLEFT",cti.target.hp,"BOTTOMLEFT")
						cti.target.mpbar:SetPoint("TOPLEFT",cti.target.mp,"TOPLEFT")
						cti.target.ep:SetPoint("TOPLEFT",cti.target.mp,"BOTTOMLEFT")
						cti.target.epbar:SetPoint("TOPLEFT",cti.target.ep,"TOPLEFT")

						cti.target.mpbar:SetVisible(true)
						cti.target.mp:SetVisible(true)
						cti.target.epbar:SetVisible(false)
						cti.target.ep:SetVisible(false)
					
						cti.target.mppct:SetVisible(true)
						cti.target.eppct:SetVisible(false)
						oldCalling = "mage"
					else
						if targetDetail.calling == nil then
							
							cti.target.mpbar:SetVisible(false)
							cti.target.mp:SetVisible(false)
							cti.target.epbar:SetVisible(false)
							cti.target.ep:SetVisible(false)
							
							cti.target.mppct:SetVisible(false)
							cti.target.eppct:SetVisible(false)
							cti.target.name:SetFontColor(1,1,1,1)
						else
							if targetDetail.calling == "none" then
								cti.target.name:SetFontColor(1,1,1,1)
							end
						end
					end
				end
			end
		end
	else
		
	oldCalling = nil
	end
	
if targetDetail ~= nil then
	if targetDetail.role ~= nil then
		if targetDetail.role == "tank" then
			cti.target.roleTank:SetVisible(true)
			cti.target.roleHeal:SetVisible(false)
			cti.target.roleDps:SetVisible(false)
			cti.target.roleSupport:SetVisible(false)
		end
		if targetDetail.role == "heal" then
			cti.target.roleTank:SetVisible(false)
			cti.target.roleHeal:SetVisible(true)
			cti.target.roleDps:SetVisible(false)
			cti.target.roleSupport:SetVisible(false)
		end
		if targetDetail.role == "dps" then
			cti.target.roleTank:SetVisible(false)
			cti.target.roleHeal:SetVisible(false)
			cti.target.roleDps:SetVisible(true)
			cti.target.roleSupport:SetVisible(false)
		end
		if targetDetail.role == "support" then
			cti.target.roleTank:SetVisible(false)
			cti.target.roleHeal:SetVisible(false)
			cti.target.roleDps:SetVisible(false)
			cti.target.roleSupport:SetVisible(true)
		end
	end
else
	cti.target.roleTank:SetVisible(false)
	cti.target.roleHeal:SetVisible(false)
	cti.target.roleDps:SetVisible(false)
	cti.target.roleSupport:SetVisible(false)
end
------------------------------------------------------------------------------------------------------------------------------lenname
	if cti.options.panel2.combo:GetChecked() == false then
		cti.target.cp:SetWidth(0)
	else
	end
	
	if cti.options.panel2.name:GetChecked() == false then
		cti.target.name:SetWidth(0)
	else
		cti.target.name:SetWidth(lenname)
	end
	
	if cti.options.panel2.hp:GetChecked() == false then
		cti.target.hp:SetWidth(0)
		cti.target.hpbar:SetWidth(0)
	else
		cti.target.hp:SetWidth(lenname)
	end

	if cti.options.panel2.mp:GetChecked() == false then
		cti.target.mp:SetWidth(0)
		cti.target.mpbar:SetWidth(0)
	else
		cti.target.mp:SetWidth(lenname)
	end

	if cti.options.panel2.ep:GetChecked() == false then
		cti.target.ep:SetWidth(0)
		cti.target.epbar:SetWidth(0)

	else
		cti.target.ep:SetWidth(lenname)
	end

	if cti.options.panel2.hpPct:GetChecked() == false then
		cti.target.hppct:SetWidth(0)
	else
	end

	if cti.options.panel2.mpPct:GetChecked() == false then
		cti.target.mppct:SetWidth(0)
	else
	end

	if cti.options.panel2.epPct:GetChecked() == false then
		cti.target.eppct:SetWidth(0)
	else
	end

	if cti.options.panel2.level:GetChecked() == false then
		cti.target.nameToken:SetWidth(0)
	else
	end
																	--------------------------- combat option visibility
		if cti.options.panel2.combat:GetChecked() == true then
			if combatCheck == true then
				cti.target:SetVisible(true)
			else
				cti.target:SetVisible(false)
			end
		else
			
		end
		sizingit()
	end

local function ctiRedraw()
		local myMouse = Inspect.Mouse()
	
		if  myMouse.Left == nil and myMouse.Right == nil then
			cti.target:SetPoint("TOPLEFT",UIParent,"TOPLEFT",myMouse.x + cti.target.cp:GetWidth() + ctiV.gui.position.x ,myMouse.y + ctiV.gui.position.y)
		end

end
																			--Clicky the option icon
function cti.options.Event:LeftClick()
	if cti.options.panel:GetVisible() ~= true and cti.options.panel2:GetVisible() ~= true then
		cti.options.panel:SetVisible(true)
	else
		cti.options.panel2:SetVisible(false)
		cti.options.panel:SetVisible(false)
	end
	
		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			roles = cti.options.panel2.roles:GetChecked(),
			combatCheck = cti.options.panel2.combat:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
		}
end


function valShort(num)
	if num ~= nil then
		local val = tonumber(num)
		if val >= 10000000 then 
			return string.format( "%.1f m", val / 1000000 ) 
		elseif val >= 1000000 then
			return string.format( "%.2f m", val / 1000000 ) 
		elseif val >= 100000 then
			return string.format( "%.0f k", val / 1000 ) 
		elseif val >= 10000 then
			return string.format( "%.1f k", val / 1000 ) 
		else
			return val
		end
	else
		return 0
	end
end

function cti.options.Event:RightClick()
	dump(targetDetail)
end

function cti.options.panel.options.Event:LeftClick()
	if cti.options.panel:GetVisible() == true or cti.options.panel2:GetVisible() == true then 
		cti.options.panel:SetVisible(false)
		cti.options.panel2:SetVisible(false)
	else
		cti.options.panel:SetVisible(true)
	end	
		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			combatCheck = cti.options.panel2.combat:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
		}
end

local function ctisave(addon)
   if addon == "CursorTargetInfo" then
     if ctisaver then
		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			combatCheck = cti.options.panel2.combat:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
			}     
		print ("Save Click")
		else
		print ("No Click")
		end
   end
end

local function ctiload(addon)
   if addon == "CursorTargetInfo" then
     if ctisaver then
		if ctisaver.xos ~= nil then cti.options.panel.xos:SetPosition( ctisaver.xos) end
		if ctisaver.yos ~= nil then cti.options.panel.yos:SetPosition( ctisaver.yos) end
		if ctisaver.mOver ~= nil then cti.options.panel.mOver:SetChecked( ctisaver.mOver) end
		if ctisaver.focus ~= nil then cti.options.panel.focus:SetPosition(ctisaver.focus) end
		if ctisaver.xos ~= nil then ctiV.gui.position.x = ctisaver.xos end
		if ctisaver.yos ~= nil then ctiV.gui.position.y = ctisaver.yos end
		if ctisaver.combo ~= nil then cti.options.panel2.combo:SetChecked( ctisaver.combo ) end
		if ctisaver.hp ~= nil then cti.options.panel2.hp:SetChecked(ctisaver.hp) end
		if ctisaver.mp ~= nil then cti.options.panel2.mp:SetChecked(ctisaver.mp) end
		if ctisaver.ep ~= nil then cti.options.panel2.ep:SetChecked(ctisaver.ep) end
		if ctisaver.level ~= nil then cti.options.panel2.level:SetChecked(ctisaver.level) end
		if ctisaver.name ~= nil then cti.options.panel2.name:SetChecked(ctisaver.name) end
		if ctisaver.hpPct ~= nil then cti.options.panel2.hpPct:SetChecked(ctisaver.hpPct) end
		if ctisaver.mpPct ~= nil then cti.options.panel2.mpPct:SetChecked(ctisaver.mpPct) end
		if ctisaver.epPct ~= nil then cti.options.panel2.epPct:SetChecked(ctisaver.epPct) end
		if ctisaver.roles ~= nil then cti.options.panel2.roles:SetChecked(ctisaver.roles) end
		if ctisaver.combatCheck ~= nil then cti.options.panel2.combat:SetChecked(ctisaver.combatCheck) end
		if ctisaver.scaleFactor ~= nil then cti.options.panel2.scaling:SetPosition(ctisaver.scaleFactor) end

		print("CTi Info Loaded.")
	 else
		print("CTi Info Load FAILED. (possibly difference in version or first time loading)")
		print("Reconstructing Save File...")
   if addon == "CursorTargetInfo" then
     if ctisaver then
		ctisaver = {
			xos = cti.options.panel.xos:GetPosition(),
			yos = cti.options.panel.yos:GetPosition(),
			mOver = cti.options.panel.mOver:GetChecked(),
			focus = cti.options.panel.focus:GetPosition(),
			combo = cti.options.panel2.combo:GetChecked(),
			hp = cti.options.panel2.hp:GetChecked(),
			mp = cti.options.panel2.mp:GetChecked(),
			ep = cti.options.panel2.ep:GetChecked(),
			level = cti.options.panel2.level:GetChecked(),
			name = cti.options.panel2.name:GetChecked(),
			hpPct = cti.options.panel2.hpPct:GetChecked(),
			mpPct = cti.options.panel2.mpPct:GetChecked(),
			epPct = cti.options.panel2.epPct:GetChecked(),
			combatCheck = cti.options.panel2.combat:GetChecked(),
			scaleFactor = cti.options.panel2.scaling:GetPosition(),
			}     
			print ("File Constructed. Save Complete.")
		else
			print ("Save Fail, save file not available.")
		end
   end
		
     end
  end
	sizingit()
  end

function ctiInCombat()
	combatCheck = true
end

function ctiOutCombat()
	combatCheck = false
end

function cti.options.panel.xos.Event:SliderChange()
	ctiV.gui.position.x = cti.options.panel.xos:GetPosition()
	cti.options.panel.xostxt:SetText("Horizontal Offset : (" .. tostring(ctiV.gui.position.x) .. ")")

	
	local myMouse = Inspect.Mouse()
	cti.target:SetPoint("TOPLEFT",UIParent,"TOPLEFT",myMouse.x + cti.target.cp:GetWidth() + ctiV.gui.position.x ,myMouse.y + ctiV.gui.position.y)

	cti.options.panel.previewTxt:SetPoint("TOPLEFT",cti.options.panel.preview,"TOPLEFT",ctiV.gui.position.x ,ctiV.gui.position.y)

	end

table.insert(Event.System.Update.Begin, {ctiRefresh, "CursorTargetInfo", "Throttled Refresh"})
table.insert(Event.System.Update.End, {ctiRedraw, "CursorTargetInfo", "Throttled Redraw"})

table.insert(Event.Addon.SavedVariables.Save.Begin, {ctisave, "CursorTargetInfo", "Save variables"})
table.insert(Event.Addon.Load.End, {ctiload, "CursorTargetInfo", "Load variables"})

table.insert(Event.System.Secure.Enter, {ctiInCombat, "CursorTargetInfo", "In Combat Call"})
table.insert(Event.System.Secure.Leave, {ctiOutCombat, "CursorTargetInfo", "Out of Combat Call"})